using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;

namespace TestMcCrypt
{
    public partial class frmTestMcCrypt : Form
    {
        private const int rfqPEM = 1421;
        private const int rfqPKCS = 2315;
        public static string modus;
        private string mcCryptExe;
        private string logFile, configFile, requestFile, replyFile;
        private int iknr, rtn;

        public frmTestMcCrypt()
        {
            InitializeComponent();
            AddEventhandler();
        }

        #region events

        private void AddEventhandler()
        {
            btnMandant.Click += new EventHandler(btnMandant_Click);
            btnActivate.Click += new EventHandler(btnActivate_Click);
            btnCreateRequest.Click += new EventHandler(btnCreateRequest_Click);
            btnImportReply.Click += new EventHandler(btnImportReply_Click);
            btnPrintRequest.Click += new EventHandler(btnPrintRequest_Click);
            btnUpdateTC.Click += new EventHandler(btnUpdateTC_Click);
            btnStatus.Click += new EventHandler(btnStatus_Click);
            btnEncrypt.Click += new EventHandler(btnEncrypt_Click);
            btnValid.Click += new EventHandler(btnValid_Click);
            btnDecrypt.Click += new EventHandler(btnDecrypt_Click);
            txtIK.TextChanged += new EventHandler(txtIK_TextChanged);
            btnLog.Click += new EventHandler(btnLog_Click);
            btnModus.Click += new EventHandler(btnModus_Click);
            btnExecute.Click += new EventHandler(btnExecute_Click);
            txtMessage.TextChanged += new EventHandler(txtMessage_TextChanged);
        }

        private void txtMessage_TextChanged(object sender, EventArgs e)
        {
            lblReturnCode.Text = "";
        }

        private void btnMandant_Click(object sender, EventArgs e)
        {
            rtn = Mandant();
        }

        private void btnActivate_Click(object sender, EventArgs e)
        {
            rtn = ActivateSN();

        }

        private void btnUpdateTC_Click(object sender, EventArgs e)
        {

            rtn = UpdateTC();
        }

        private void btnCreateRequest_Click(object sender, EventArgs e)
        {
            rtn = CreateRequest();

        }

        private void btnPrintRequest_Click(object sender, EventArgs e)
        {
            rtn = PrintRequest();
        }

        private void btnImportReply_Click(object sender, EventArgs e)
        {
            if(!File.Exists(requestFile))
            {
                return;
            }
            if(!File.Exists(replyFile))
            {
                File.Copy(requestFile, replyFile); //nur fr Testzwecke zulssig
            }
            rtn = ImportReply();

        }

        private void btnValid_Click(object sender, EventArgs e)
        {
            rtn = CertificateValid();
        }

        private void btnEncrypt_Click(object sender, EventArgs e)
        {
            if(Init() < 0)
                return;

            string inFile = logFile;

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.FileName = logFile;
            DialogResult result = ofd.ShowDialog();
            if(result == DialogResult.Cancel)
            {
                return;
            }

            inFile = ofd.FileName;
            Application.DoEvents();

            string outFile = inFile + ".ver";
            string recipient = iknr.ToString();
            rtn = Encrypt(inFile, outFile, recipient);

        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            if(Init() < 0)
                return;

            string inFile = logFile + ".ver";

            OpenFileDialog ofd = new OpenFileDialog();
            ofd.FileName = inFile;
            DialogResult result = ofd.ShowDialog();
            if(result == DialogResult.Cancel)
            {
                return;
            }

            inFile = ofd.FileName;
            Application.DoEvents();

            modus = GetModus();
            string outFile = inFile.Replace(".ver", ".plain");
            rtn = Decrypt(inFile, outFile);

        }

        private void btnStatus_Click(object sender, EventArgs e)
        {
            if(Init() == 0)
                rtn = Status();
        }

        private void btnLog_Click(object sender, EventArgs e)
        {
            if(Init() != 0)
                return;
            Process.Start("notepad.exe", logFile);
        }

        private void btnModus_Click(object sender, EventArgs e)
        {
            lblReturnCode.Text = String.Format("Mode={0}", GetModus());

        }

        private void btnExecute_Click(object sender, EventArgs e)
        {
            ExecProcess(txtMessage.Text);
        }

        private string GetModus()
        {
            Init();
            int rtn = CertificateMode();
            if(rtn == rfqPEM)
                return "PEM";
            else if(rtn == rfqPKCS)
                return "PKCS";
            else
                return "unknown";
        }

        private void txtIK_TextChanged(object sender, EventArgs e)
        {
            Init();
        }

        private void frmTestMcCrypt_Load(object sender, EventArgs e)
        {

        }

        #endregion

        private int Init()
        {
            lblReturnCode.Text = "";
            try
            {
                iknr = Convert.ToInt32(txtIK.Text);
                mcCryptExe = Application.StartupPath + @"\mcCrypt.exe";
                logFile = Application.StartupPath + @"\" + iknr.ToString() + ".log";
                configFile = Application.StartupPath + @"\" + iknr.ToString() + ".xml";
                requestFile = Application.StartupPath + @"\" + iknr.ToString() + ".crq";
                replyFile = Application.StartupPath + @"\" + iknr.ToString() + ".crp";
                string replyFile2 = Application.StartupPath + @"\" + iknr.ToString() + ".p7c";

                lblCheckIK.Visible = (txtIK.Text.Length < 8);

                lblXML.Text = Path.GetFileName(configFile);
                if(File.Exists(configFile))
                {
                    lblXML.ForeColor = Color.Black;
                }
                else
                {
                    lblXML.ForeColor = Color.Red;
                }

                lblCreateRequest.Text = Path.GetFileName(requestFile);
                if(File.Exists(requestFile))
                {
                    lblCreateRequest.ForeColor = Color.Black;
                }
                else
                {
                    lblCreateRequest.ForeColor = Color.Red;
                }

                if(File.Exists(replyFile2))
                {
                    replyFile = replyFile2;
                }
                if(File.Exists(replyFile))
                {
                    lblImportReply.Text = Path.GetFileName(replyFile);
                }

                if(File.Exists(replyFile))
                {
                    lblImportReply.ForeColor = Color.Black;
                }
                else
                {
                    lblImportReply.ForeColor = Color.Red;
                    lblImportReply.Text = "?";
                }


                return 0;
            }
            catch(Exception ex)
            {
                lblReturnCode.Text = ex.Message;
                return -1;
            }
        }

        private int ExecProcess(string param)
        {
            Cursor = Cursors.WaitCursor;
            lblReturnCode.Text = "";
            string msg = "";
            Application.DoEvents();

            try
            {

                using(Process proc = Process.Start(mcCryptExe, param))
                {

                    proc.WaitForExit();
                    switch(proc.ExitCode)
                    {
                        case 1:
                            msg = "Firmendaten sind ok";
                            break;
                        case 2:
                            msg = "Institutskennzeichen bzw. Betriebsnummer wurde aktiviert";
                            break;
                        case 3:
                            msg = "Zertifizierungsanfrage wurde erstellt";
                            break;
                        case 4:
                            msg = "Zertifikat wurde importiert - ab jetzt kann verschlsselt werden";
                            break;
                        case -1:
                            msg = "Abbruch durch Benutzer";
                            break;
                        case -2:
                            msg = "Unbekannter Fehler";
                            break;
                        case -3:
                            msg = "Unbekannter Fehler";
                            break;
                        case -4:
                            msg = "Fehler beim Lesen oder Schreiben einer Datei";
                            break;
                        case -5:
                            msg = "Ungltiger Befehl";
                            break;
                        case -6:
                            msg = "Ungltiger Parameter";
                            break;
                        case -7:
                            msg = "Firmendaten fr die Verarbeitung nicht zulssig";
                            break;
                        case -8:
                            msg = "Fehler bei der Aktivierung";
                            break;
                        case -9:
                            msg = "Ungltiges Zertifikat";
                            break;
                        case -10:
                            msg = "Fehler bei der Verschlsselung";
                            break;
                        case -11:
                            msg = "Ugltiger Typ";
                            break;
                    }

                    lblReturnCode.Text = "Returncode=" + proc.ExitCode.ToString() + " " + msg;

                    return proc.ExitCode;
                }
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
                return -1;
            }
            finally
            {
                Cursor = Cursors.Default;
            }

        }

        private int Mandant()
        {
            if(Init() < 0)
                return 0;
            string param = "Mandant "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int ActivateSN()
        {
            if(Init() < 0)
                return 0;
            string param = "Activate "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int UpdateTC()
        {
            if(Init() < 0)
                return 0;
            string param = "UpdateTC "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int CertificateMode()
        {
            if(Init() < 0)
                return 0;
            string param = "CertificateMode "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return ExecProcess(param);
        }

        private int CertificateValid()
        {
            if(Init() < 0)
                return 0;
            string param = "CertificateValid "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int Status()
        {
            if(Init() < 0)
                return 0;
            string param = "Status "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int CreateRequest()
        {
            if(Init() < 0)
            {
                return rtn;
            }

            int iMode = CertificateMode();
            if(iMode == rfqPEM)
                modus = "PEM";
            else if(iMode == rfqPKCS)
                modus = "PKCS";
            else
            {
                frmMode m = new frmMode();
                m.ShowDialog(this);

            }

            if(modus == "PKCS" || modus == "PEM")
            {
                string param = "CreateRequest "
                     + @" /Mode " + modus
                     + @" /Request " + requestFile
                     + @" /config " + configFile
                     + @" /log " + logFile;

                txtMessage.Text = param;

                return 0;
            }
            else
                return -1;
        }

        private int PrintRequest()
        {
            if(Init() < 0)
                return 0;
            string param = "PrintRequest "
                + @"/config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int ImportReply()
        {
            if(Init() < 0)
                return 0;
            string param = "ImportReply "
                + @" /Mode " + GetModus()
                + @" /Reply " + replyFile
                + @" /config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int Encrypt(string inputFile, string outputFile, string recipient)
        {
            if(Init() < 0)
                return 0;

            string param = "Encrypt "
                + @" /Plain " + inputFile
                + @" /Mode " + GetModus()
                + @" /Crypt " + outputFile
                + @" /Recipient " + recipient
                + @" /config " + configFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

        private int Decrypt(string inputFile, string outputFile)
        {
            if(Init() < 0)
                return 0;

            string param = "Decrypt "
                + @" /Mode " + GetModus()
                + @" /config " + configFile
                + @" /Crypt " + inputFile
                + @" /Plain " + outputFile
                + @" /log " + logFile;

            txtMessage.Text = param;

            return 0;
        }

    }
}